/*
 *	Custom SilkScreenArea
 *	v1.0
 *	April 24. 2001
 *	
 *	by Collin R. Mulliner <palm@mulliner.org>
 *		web: www.mulliner.org/palm
 *
 *	DON'T EDIT THIS FILE !
 */
 
#include <stdio.h>

#define vchrMenu		0x0105
#define vchrLaunch		0x0108
#define vchrKeyboard		0x0109
#define vchrFind		0x010a
#define vchrCalc		0x010b
#define vchrKeyboardAlpha	0x0110
#define vchrKeyboardNumeric	0x0111
#define vchrTsm1		0x0118
#define vchrTsm2		0x0119
#define vchrTsm3		0x011a
#define vchrTsm4		0x011b

#define shiftKeyMask		0x0001
#define capsLockMask		0x0002
#define numLockMask		0x0004
#define commandKeyMask		0x0008
#define optionKeyMask		0x0010
#define controlKeyMask		0x0020
#define autoRepeatKeyMask	0x0040
#define doubleTapKeyMask	0x0080
#define poweredOnKeyMask	0x0100
#define appEvtHookKeyMask	0x0200
#define libEvtHookKeyMask	0x0400

#define virtualKeyMask	(appEvtHookKeyMask | libEvtHookKeyMask | commandKeyMask)

#define SWAP4(x) x = (((x & 0xff000000) >> 24) | ((x & 0x00ff0000) >> 8) | ((x & 0x0000ff00) << 8) | ((x & 0x000000ff) << 24));
#define SWAP2(x) x = (((x & 0xff00) >> 8) | ((x & 0x00ff) << 8));

#pragma pack(2)
typedef struct PointType {
	unsigned short x;
	unsigned short y;
} PointType;
#pragma

#pragma pack(2)
typedef struct RectangleType {
	PointType topLeft;
	PointType extent;
} RectangleType;
#pragma

#pragma pack(2)
typedef struct PenBtnInfoType {
	RectangleType boundsR;
	unsigned short asciiCode;
	unsigned short keyCode;
	unsigned short modifiers;
} PenBtnInfoType;
#pragma

#pragma pack(2)
typedef struct PenBtnListType {
	unsigned short numButtons;
//	PenBtnInfoType buttons[1];
} PenBtnListType;
#pragma

#pragma pack(2)
typedef struct SilkscreenAreaType {
	RectangleType bounds;
	unsigned int areaType;
	unsigned short index;
} SilkscreenAreaType;
#pragma

#pragma pack(2)
typedef struct {
	unsigned short one;
	unsigned int poem;

	unsigned int bytes4;
	unsigned short bytes2;
	
	// screen area
	SilkscreenAreaType screenArea;
	// alpha - graffiti area
	SilkscreenAreaType graffitiAreaA;
	// numeric - graffiti area
	SilkscreenAreaType graffitiAreaN;
	
	PenBtnListType buttonList;
	// PenBtnInfoType buttonInfo[NUM_BUTTONS];
} silk_res_type;
#pragma
